from toee import *

from utilities import *

familiar_table = {
12045: 14900,
12046: 14901,
12047: 14902,
12048: 14903,
12049: 14904,
12050: 14905,
12051: 14906,
12052: 14907,
12053: 14908,
12054: 14909
}

def OnBeginSpellCast( spell ):
	print "Summon Familiar OnBeginSpellCast"
	print "spell.target_list=", spell.target_list
	print "spell.caster=", spell.caster, " caster.level= ", spell.caster_level
	game.particles( "sp-conjuration-conjure", spell.caster )

def	OnSpellEffect( spell ):
	print "Summon Familiar OnSpellEffect"

	spell.duration = 4800
	master = spell.caster

	# get the proto_id for this familiar 
	familiar_proto_id = FindFamiliarProto( spell.caster, 1 )
	if (familiar_proto_id == 0):	#  not a recognized familiar type
		return SKIP_DEFAULT
	
	# creates random ID number
	ID_number = game.random_range( 1,2147483647 )
	ID_number = ID_number^game.random_range( 1,2147483647 )#xor with next "random" number in line, should be more random
		
	# create familiar
	spell.summon_monsters( 1, familiar_proto_id )
	
	# get familiar's handle
	familiar_obj = GetFamiliarHandle( spell, familiar_proto_id )
	if ( familiar_obj == OBJ_HANDLE_NULL ): # no new familiar present
		return SKIP_DEFAULT
	
	# summoning effect
	game.particles( 'Orb-Summon-Air-Elemental', familiar_obj )
		
	# assigns familiar ownership	
	assign_spell_flags( familiar_obj, ID_number )
	inv_proto = FindFamiliarProto( spell.caster, 0 )
	familiar = spell.caster.item_find_by_proto( inv_proto )
	assign_spell_flags( familiar, ID_number )
	
	#game.particles( "sp-summon monster II", game.party[0] )
	
	# sets familiar's stat's and bonuses depending on it's masters level
	master_level = GetLevel( spell.caster )
	f_level = ( ( master_level + 1 ) / 2 )
	f_hp = ( ( spell.caster.stat_level_get( stat_hp_max ) ) / 2 ) ## familiar's hp = i/2 masters hp
	old_hp = familiar_obj.stat_level_get( stat_hp_max )
	if ( old_hp <= f_hp ):
		new_hp = familiar_obj.stat_base_set( stat_hp_max, f_hp )
	## This next bit gives the familiar it's masters BAB.  The familiar should have a BAB (without the masters BAB) of zero, but since
	## the game engine doesn't allow for Weapon Finesse with natural attacks( which would let the familiar use their dexterity modifier
	## instead of the strength modifier), I fiddled with the  "to hit" in the protos to counteract the negative attack modifier do to 
	## low strength and add the dexterity modifier. - Ceruleran the Blue ##
	f_to_hit = spell.caster.stat_base_get(stat_attack_bonus)
	new_to_hit = familiar_obj.condition_add_with_args( 'To Hit Bonus', f_to_hit, 0 )
	new_int = familiar_obj.stat_base_set( stat_intelligence, ( 5 + f_level ) ) ## familiar INT bonus
	armor = familiar_obj.condition_add_with_args( 'Amulet of Natural Armor', (f_level), 0 ) ## Natrual Armor bonus
	if ( master_level >= 11 ):
		spell_resistance = familiar_obj.condition_add_with_args( 'Monster Spell Resistance', ( 5 + master_level ), 0 ) ## spell resistance
	## familiar uses masters saving throw bonuses if they are higher than it's own.
	fortitude_bonus = Fortitude( spell.caster )
	if ( fortitude_bonus >= 3 ):
		fortitude_save = familiar_obj.condition_add_with_args( 'Saving Throw Resistance Bonus', 'saving_throw_fortitude', fortitude_bonus )
	reflex_bonus = Reflex( spell.caster )
	if ( reflex_bonus >= 3 ):
		reflex_save = familiar_obj.condition_add_with_args( 'Saving Throw Resistance Bonus', 'saving_throw_reflex', reflex_bonus )
	will_bonus = Will( spell.caster )
	if ( will_bonus >= 1 ):
		wlll_save = familiar_obj.condition_add_with_args( 'Saving Throw Resistance Bonus', 'saving_throw_will', will_bonus )
	
	# add familiar to follower list for spell_caster
	if not ( spell.caster.follower_atmax() ):
		spell.caster.follower_add( familiar_obj )
	else:
		spell.caster.ai_follower_add( familiar_obj )
	
	# add familiar_obj to d20initiative, and set initiative to spell_caster's
	caster_init_value = spell.caster.get_initiative()
	familiar_obj.add_to_initiative()
	familiar_obj.set_initiative( caster_init_value )
	game.update_combat_ui()

	# familiar should disappear when duration is over, apply "TIMED_DISAPPEAR" condition
	familiar_obj.condition_add_with_args( 'sp-Summoned', spell.id, spell.duration, 0 )
	
	# add familiar to target list
	spell.num_of_targets = 1
	spell.target_list[0].obj = familiar_obj

	spell.spell_end( spell.id )

def OnBeginRound( spell ):
	print "Summon Familiar OnBeginRound"

def OnEndSpellCast( spell ):
	print "Summon Familiar OnEndSpellCast"
	for f,p in familiar_table.items():
		itemA = spell.caster.item_find_by_proto( f )
		clear_spell_flag( itemA )
	
def FindFamiliarProto( master, x ):
	for f,p in familiar_table.items():
		itemC = master.item_find_by_proto( f )
		if ( itemC != OBJ_HANDLE_NULL ):
			if x :
				return p
			else:
				return f
	return 0
	
def get_spell_flag(obj):
	return obj.obj_get_int(obj_f_secretdoor_dc)

def FindMaster( npc ): #in case you need it
	for p_master in game.obj_list_vicinity( npc.location, OLC_CRITTERS ):
		for x,y in familiar_table.items():
			item = p_master.item_find_by_proto( x )
			if (item != OBJ_HANDLE_NULL):
				if ( get_spell_flag(item) == get_spell_flag( npc ) ):
					return p_master
	return OBJ_HANDLE_NULL
	
def GetFamiliarHandle( spell, familiar_proto_id ):
	for npc in game.obj_list_vicinity( spell.target_loc, OLC_CRITTERS ):
		if (npc.name == familiar_proto_id):
			if not ( get_spell_flag( npc ) ):
				return npc
	return OBJ_HANDLE_NULL
	
def clear_spell_flag( obj ):
	obj.obj_set_int( obj_f_secretdoor_dc, 0 )

def assign_spell_flags( obj, val ):
	obj.obj_set_int( obj_f_secretdoor_dc, val )
	return obj.obj_get_int( obj_f_secretdoor_dc )
	
def GetLevel( npc ):
	level = npc.stat_level_get(stat_level_sorcerer) + npc.stat_level_get(stat_level_wizard)
	return level
	
def Fortitude( npc ):
	bonus = 0
	level = npc.stat_level_get(stat_level_barbarian) + npc.stat_level_get(stat_level_cleric) + npc.stat_level_get(stat_level_druid) + npc.stat_level_get(stat_level_fighter) + npc.stat_level_get(stat_level_paladin) + npc.stat_level_get(stat_level_ranger) + npc.stat_level_get(stat_level_monk)
	if ( level != 0 ):
		bonus = ( ( level / 2 ) + 2 )
	level = npc.stat_level_get(stat_level_bard) + npc.stat_level_get(stat_level_rogue) + npc.stat_level_get(stat_level_sorcerer) + npc.stat_level_get(stat_level_wizard)
	if ( level != 0 ):
		bonus = bonus + ( level / 3 )
	return bonus

def Reflex( npc ):
	bonus = 0
	level = npc.stat_level_get(stat_level_barbarian) + npc.stat_level_get(stat_level_cleric) + npc.stat_level_get(stat_level_druid) + npc.stat_level_get(stat_level_fighter) + npc.stat_level_get(stat_level_paladin) + npc.stat_level_get(stat_level_sorcerer) + npc.stat_level_get(stat_level_wizard)
	if ( level != 0 ):
		bonus = ( level / 3 )
	level = npc.stat_level_get(stat_level_ranger) + npc.stat_level_get(stat_level_rogue) + npc.stat_level_get(stat_level_monk) + npc.stat_level_get(stat_level_bard)
	if ( level != 0 ):
		bonus = bonus + ( ( level / 2 ) + 2 )
	return bonus

def Will( npc ):
	bonus = 0
	level = npc.stat_level_get(stat_level_bard) + npc.stat_level_get(stat_level_cleric) + npc.stat_level_get(stat_level_druid) + npc.stat_level_get(stat_level_monk) + npc.stat_level_get(stat_level_sorcerer) + npc.stat_level_get(stat_level_wizard)
	if ( level != 0 ):
		bonus = ( ( level / 2 ) + 2 )
	level = npc.stat_level_get(stat_level_barbarian) + npc.stat_level_get(stat_level_fighter) + npc.stat_level_get(stat_level_paladin) + npc.stat_level_get(stat_level_ranger) + npc.stat_level_get(stat_level_rogue)
	if ( level != 0 ):
		bonus = bonus + ( level / 3 )
	return bonus



