from toee import *

from __main__ import game

from utilities import *

familiar_table = {
12045: 14900,
12046: 14901,
12047: 14902,
12048: 14903,
12049: 14904,
12050: 14905,
12051: 14906,
12052: 14907,
12053: 14908,
12054: 14909
}


def san_dying( attachee, triggerer ):
	# identify familiar dying and match to familiar inventory icon
	familiar_proto = FindFamiliarInvType( attachee )
	if ( familiar_proto == OBJ_HANDLE_NULL ):
		return SKIP_DEFAULT # not a valid familiar type
	
	# search for familiar inventory icon in all PCs' inventory
	for obj in game.obj_list_vicinity( attachee.location, OLC_CRITTERS ):
		inv_familiar = obj.item_find_by_proto( familiar_proto )
		if ( inv_familiar != OBJ_HANDLE_NULL ):
			# check for correct ID number
			if ( get_spell_flag( inv_familiar ) == get_spell_flag( attachee ) ):
				# destroys familiar in owner's inventory and removes one point of CON from owner
				inv_familiar.destroy()
				currentcon = obj.stat_base_get( stat_constitution )
				newcon = currentcon - 1
				obj.stat_base_set( stat_constitution, newcon )
				return SKIP_DEFAULT
	return RUN_DEFAULT

def FindFamiliarInvType( attachee ):
	for f,p in familiar_table.items():
		if (attachee.name == p):
			return f
	return OBJ_HANDLE_NULL

def get_spell_flag(obj):
	return obj.obj_get_int(obj_f_secretdoor_dc)


	

	